"=====================================================================
" cream.vim -- General loader, the "Main()" function of Cream.
"
" Version:	0.23
" Source:	http://cream.sourceforge.net
" Description:  see docs/README.txt
"
" source file function {{{1
function! Cream_source(file)
" source a file if available
	if filereadable(a:file) > 0
		execute "source " . a:file
		return 1
	else
		return -1
	endif
endfunction

if has("gui_running")
    "colorscheme darkblue
    source $VIM/vimfiles/colors/cream-colors-oceandeep.vim
endif

map <F12> :grep "^[a-zA-Z_].*([^;]*$"  % <CR> 
map <S-F12> :grep -i "^[ \ta-z_]*[^;]\b\(proc\\\|struct\\\|macro\)\b" % <CR>
map <F4>  [I:let nr = input("Which one: ")<Bar>exe "normal " . nr ."[\t"<CR>

" Title Case
imap <silent> <F5>   <C-o>:call Cream_capitalize("i")<CR>
vmap <silent> <F5>   :<C-u>call Cream_capitalize("v")<CR>
" UPPERCASE
imap <silent> <S-F5> <C-o>:call Cream_case_upper("i")<CR>
vmap <silent> <S-F5> :<C-u>call Cream_case_upper("v")<CR>
" lowercase
imap <silent> <M-F5> <C-o>:call Cream_case_lower("i")<CR>
vmap <silent> <M-F5> :<C-u>call Cream_case_lower("v")<CR>
" rEVERSE CASE
imap <silent> <C-F5> <C-o>:call Cream_case_reverse("i")<CR>
vmap <silent> <C-F5> :<C-u>call Cream_case_reverse("v")<CR>

" Block comments (Enhanced Commentify) {{{1

imap <silent> <F6>   <C-o>:call Cream_commentify("i")<CR>
vmap <silent> <F6>   :<C-u>call Cream_commentify("v")<CR>

imap <silent> <S-F6> <C-o>:call Cream_decommentify("i")<CR>
vmap <silent> <S-F6> :<C-u>call Cream_decommentify("v")<CR>

imap <silent> <M-F6> <C-o>:call Cream_commentify_noindent("i")<CR>
vmap <silent> <M-F6> :<C-u>call Cream_commentify_noindent("v")<CR>
imap <silent> <C-F6> <C-o>:call Cream_commentify_noindent("i")<CR>
vmap <silent> <C-F6> :<C-u>call Cream_commentify_noindent("v")<CR>

map <F8> :Tlist <CR> 
imap <F8> <ESC>:Tlist <CR>

noremap <S-F11> :bprevious<CR>
inoremap <S-F11> <esc>:bprevious<CR>
noremap <F11> :bnext<CR>
inoremap <F11> <esc>:bnext<CR>

