" Vim syntax file
" Language:	Microsoft Assembler (80x86)
" Maintainer:	Rob Brady <robb@datatone.com>
" Last Change:	$Date: 2003/11/24 05:03:08 $
" URL: http://www.datatone.com/~robb/vim/syntax/asm.vim
" $Revision: 1.1.1.1 $

" For version 5.x: Clear all syntax items
" For version 6.x: Quit when a syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

syn case ignore


" syn match asmType "\.word"

syn match asmIdentifier	"[a-z_$][a-z0-9_$]*"
syn match asmLabel		"^[A-Z_$][A-Z0-9_$]*:"he=e-1
syn match asmDecimal		"\d*"
syn match asmBinary		"[0-1]\+b"  "put this before hex or 0bfh dies!
syn match asmHexadecimal	"[0-9]\x*h"
syn match asmFloat		"[0-9]\x*r"


syn match asmComment		";.*"
syn region asmString		start=+[']+ end=+[']+ 
syn region asmString2		start=+["]+ end=+["]+ 
syn keyword asmpseudoinstr	AND BYTE PTR CODEPTR DATAPTR DUP DWORD EQ FAR
syn keyword asmpseudoinstr	ASSUME NOTHING UNION REQ TEXTEQU NOLIST LISTALL STRUCT INCLUDE INCLUDELIB 
syn keyword asmpseudoinstr	PUBLIC MODEL DATA SEGMENT CONST CODE 
syn keyword asmpseudoinstr	PROC ENDP LOCAL OPTION PROTO IF DUP ELSEIF ELSE ENDIF 
syn keyword asmpseudoinstr	REPEAT UNTIL UNTILCXZ WHILE ENDW BREAK CONTINUE 
syn keyword asmpseudoinstr	MACRO ENDM EXITM 
syn keyword asmpseudoinstr	FOR FORC GOTO DB DW DD DQ PTR NEAR FAR SHORT EXTRN EQU SIZEOF OFFSET ADDR 
syn keyword asmpseudoinstr	STRUC INVOKE FLAT STDCALL CASEMAP NONE USES POPUP MENUITEM FONT CAPTION 
syn keyword asmpseudoinstr	TYPEDEF LANGUAGE DEFINE VALUE BLOCK FILESUBTYPE FILEOS FILETYPE 
syn keyword asmpseudoinstr	FWORD GE GT HIGH LARGE LE LOW LT MOD NE NEAR
syn keyword asmpseudoinstr	NOT OFFSET OR PROC PWORD QWORD SEG SHORT TBYTE
syn keyword asmpseudoinstr	TYPE WORD PARA

syn keyword asmDirective	ALIGN ARG ASSUME CODESEG COMM
syn keyword asmDirective	CONST DATASEG DB DD DF DISPLAY DOSSEG DP
syn keyword asmDirective	DQ DT DW ELSE ELSEIF EMUL END ENDIF ENDM ENDP
syn keyword asmDirective	ENDS ENUM EQU PROC PUBLIC PUBLICDLL RADIX
syn keyword asmDirective	EXTRN FARDATA GLOBAL RECORD SEGMENT SMALLSTACK
syn keyword asmDirective	GROUP IF IF1 IF2 IFB IFDEF IFDIF IFDIFI
syn keyword asmDirective	IFE IFIDN IFIDNI IFNB IFNDEF INCLUDE INCLUDLIB
syn keyword asmDirective	LABEL LARGESTACK STACK STRUC SUBTTL TITLE
syn keyword asmDirective	MODEL NAME NOEMUL UNION USES VERSION
syn keyword asmDirective	ORG FLAT INVOKE
syn keyword asmDirective   AAA AAD AAM AAS ADC ADD AND ARPL BOUND 
syn keyword asmDirective   CALL CBW CLC CLD CLI CLTS CMC CMP CMPSB CMPSW CWD 
syn keyword asmDirective   DAA DAS DEC DIV ENTER ESC HLT IDIV IMUL IN 
syn keyword asmDirective   INC INSB INSW INT INTO IRET JA JAE JB JBE JCXZ 
syn keyword asmDirective   JC JNC JE JNGE JNG JNL JG JGE JL JLE JMP JNB 
syn keyword asmDirective   JNBE JNE JNLE JNO JNP JNZ JPO JZ JO JP JS 
syn keyword asmDirective   JNS LAHF LAR LDS LEA LEAVE LES LGDT LIDT 
syn keyword asmDirective   LLDT LMSW LOCK LODSB LODSW LOOP LOOPNZ 
syn keyword asmDirective   LOOPZ LSL LTR MOV MOVSB MOVSW MUL NEG 
syn keyword asmDirective   NOP NOT OR OUT OUTSB OUTSW POP POPA 
syn keyword asmDirective   POPF PUSH PUSHA PUSHF RCL RCR REP REPNZ REPZ 
syn keyword asmDirective   RET REFT ROL ROR SAHF SAR SAL SBB SCASB SCASW 
syn keyword asmDirective   SGDT SHL SHR SLDT SMSW STC STD STI STOSB STOSW 
syn keyword asmDirective   STR SUB TEST WAIT VERR VERW XCHG XLAT XOR BSF BSR 
syn keyword asmDirective   BT BTC BTR BTS CDQ CWDE IRETD LFS LGS LSS 
syn keyword asmDirective   MOVSX MOVZX POPAD POPFD PUSHAD PUSHFD 
syn keyword asmDirective   SETA SETB SETBE SETE SETG SETL SETLE SETNB SETNE 
syn keyword asmDirective   SETNL SETNO SETNP SETNS SETO SETP SETS SHLD SHRD 
syn keyword asmDirective   CMPSD STOSD LODSD MOVSD SCASD INSD OUTSD JECXZ 
syn keyword asmDirective   BSWAP CMPXCHG INVD INVLPG WBINVD XADD FABS FADD 
syn keyword asmDirective   FADDP FBLD FBSTP FCHS FCLEX FCOM FCOMP FCOMPP 
syn keyword asmDirective   FDECSTP FDISI FDIV FDIVP FDIVR FDIVRP FENI 
syn keyword asmDirective   FFREE FIADD FIACOM FIACOMP FIDIV FIDIVR 
syn keyword asmDirective   FILD FIMUL FINCSTP FINIT FIST FISTP FISUB 
syn keyword asmDirective   FISUBR FLD FLDCWR FLDENV FLDLG2 FLDLN2 FLDL2E 
syn keyword asmDirective   FLDL2T FLDPI FLDZ FLD1 FLDCW FMUL FMULP FNOP 
syn keyword asmDirective   FNSTS FPATAN FPREM FPTAN FRNDINT FSAVENT FSCALE 
syn keyword asmDirective   FSETPM FSQRT FST FSTCW FSTENV FSTP FSTSW FSUB 
syn keyword asmDirective   FSUBP FSUBR FSUBRP FTST FWAIT FXAM FXCH FXTRACT FYL2X 
syn keyword asmDirective   FYL2XPI F2XM1 FCOS FSIN FPREM1 FSINCOS FUCOM FUCOMP FUCOMPP  
syn match   asmMODEL	"\.model"
syn match   asmMODEL	"\.186"
syn match   asmMODEL	"\.286"
syn match   asmMODEL	"\.286c"
syn match   asmMODEL	"\.286p"
syn match   asmMODEL	"\.287"
syn match   asmMODEL	"\.386"
syn match   asmMODEL	"\.386c"
syn match   asmMODEL	"\.386p"
syn match   asmMODEL	"\.387"
syn match   asmMODEL	"\.486"
syn match   asmMODEL	"\.486c"
syn match   asmMODEL	"\.486p"
syn match   asmMODEL	"\.8086"
syn match   asmMODEL	"\.8087"
syn match   asmMODEL	"\.ALPHA"
syn match   asmMODEL	"\.CODE"
syn match   asmMODEL	"\.DATA"

syn keyword asmRegister	AX BX CX DX SI DI BP SP
syn keyword asmRegister	ES DS SS CS GS ST CR DR TR
syn keyword asmRegister	AH BH CH DH AL BL CL DL
syn keyword asmRegister	EAX EBX ECX EDX ESI EDI EBP ESP EFLAGS FLAGS GDTR LDTR IDTR

" Define the default highlighting.
" For version 5.7 and earlier: only when not done already
" For version 5.8 and later: only when an item doesn't have highlighting yet
if version >= 508 || !exists("did_asm_syntax_inits")
  if version < 508
    let did_asm_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

  " The default methods for highlighting.  Can be overridden later
  HiLink asmLabel	 Label
  HiLink asmComment	 Comment 
  HiLink asmDirective	 Statement
  HiLink asmpseudoinstr Statement
  HiLink asmString2     String
  HiLink asmString	 String
  HiLink asmMODEL	 SpecialChar
  HiLink asmHexadecimal Number
  HiLink asmDecimal	 Number
  HiLink asmBinary	 Number
  HiLink asmFloat	 Number
  HiLink asmOpcode      Operator
  HiLink asmIdentifier  Identifier
  HiLink asmRegister    Type
  delcommand HiLink
endif

let b:current_syntax = "asm"

" vim: ts=8
